#include "stdafx.h"
#include "Pole.h"

static void * pole[MAX_POCET_PRVKU];

int pridej(void * prvek, int (*p)(void *, void *))
{
	if (pole[MAX_POCET_PRVKU-1] != NULL)
		// posledni prvek v poli je obsazen, vracime neco nenuloveho jako indikaci chyby
		return -1;

	int i = 0; // index, kterym budeme postupne prochazet od zacatku prvky pole a hledat,
	           // kde je misto, kam patri nas nove pridavany
	
	// prochazime pole od zacatku a dokud tam jsou nejake prvky a tyto prvky jsou mensi
	// nez nas pridavany, postupujeme dal
	// Cyklus musi skoncit, protoze na konci je minimalne jedno policko, ktere obsahuje
	// NULL - viz if na zacatku funkce.
	while (pole[i] != NULL && p(pole[i], prvek) < 0)
		i++;

	// nyni mame v i index v poli, kam nas nove pridavany prvek patri. Dame ho tedy tam
	// a zapamatujeme si, co bylo na tomto miste predtim
	void * minuly = pole[i];
	pole[i] = prvek;

	// a pokud neco bylo na miste, kam jsme dali novy prvek, musime to dat na dalsi misto
	// a pokud je neco na nem, opet to posunout atd.
	while (minuly != NULL)
	{
		i++; // posuneme se na dalsi policko

		// a prohodime to co je na tomto policku s minulym
		void * p = pole[i];
		pole[i] = minuly;
		minuly = p;

		// tento cyklus opet musi skoncit, protoze na konci je minimalne jedno volne policko
		// (obsahujici NULL) a to se jednou da do promenne "minuly"
	}
}


void * vrat_mi_prvni_a_vyjmi()
{
	// vracet budeme prvni prvek, tak si ho zapamatujeme
	void * ke_vraceni = pole[0];
	
	// a vsechny ostatni posuneme o jednu pozici doleva (prvni se prepise)
	int i = 1;
	while (i < MAX_POCET_PRVKU && pole[i] != NULL)
	{
		pole[i-1] = pole[i];
		pole[i] = NULL;
		i++;
	}

	// a vratime prvni, ktery jsme si bokem zapamatovali
	return ke_vraceni;
}
